<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DB\StorageProcedure\Param;

class CodigoExternoCliente extends \Teknisa\MAN\Controllers\TeknisaCrud {
    protected $dataSourceName = 'ger12400_relacionaCodigoExternoCliente';
    protected $utilService;
    protected $codigoExternoClientes;
    protected $dataSourceNameFind = 'ger12400_relacionaCodigoExternoCliente';
    protected $parameterBagColumnsFind = array('CDFILIAL','NRORG','CDCLIENTE');
    
    public function __construct ($crudService, $parameterBag, $entityManager, Utilities\Util $utilService, Services\CodigoExternoClienteService $codigoExternoClientes ){
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
		$this->entityManager = $entityManager;
		$this->codigoExternoClientes = $codigoExternoClientes;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'ger12400_relacionaCodigoExternoCliente';
        $this->parameterBagColumns = array('NRORG','CDCLIENTE','CDFILIAL');
    	parent::find($request, $response);
    
    }
    
    public function findProduto( $request, $response) {
        $this->dataSourceName = $this->dataSourceNameFind;
        $this->parameterBagColumns = $this->parameterBagColumnsFind;
        parent::find($request, $response);
    }
    
    public function saveCodigoExterno(DTO\Request $request, DTO\Response $response){
        try{
            $row = $this->utilService->getParamsAsArray($request); 
            if($row[0]['__is_new'] == true){
            $NRORG             = $row[0]['NRORG'];
            $CDFILIAL          = $row[0]['CDFILIAL'];
            $CDCLIENTE         = $row[0]['CDCLIENTE'];
            $CDEXCLIENTEIMP    = $row[0]['CDEXCLIENTEIMP'];
            $params = array(
                'CDEXCLIENTEIMP' => $CDEXCLIENTEIMP,
                'CDCLIENTE' => $CDCLIENTE,
                'CDFILIAL' => $CDFILIAL,
                'NRORG' => $NRORG );
            $result = $this->codigoExternoClientes->saveCodigoExterno($params);  
            $response->addDataSet(new DataSet('ger12400_relacionaCodigoExternoCliente',array()));
            }else{
                $NRORG             = $row[0]['NRORG'];
                $CDFILIAL          = $row[0]['CDFILIAL'];
                $CDCLIENTE         = $row[0]['CDCLIENTE'];
                $CDEXCLIENTEIMP    = $row[0]['CDEXCLIENTEIMP'];
                $OLD_CDEXCLIENTEIMP = $row[0]['OLD_CDEXCLIENTEIMP'];
                $OLD_CDFILIAL       = $row[0]['OLD_CDFILIAL'];
                $params = array(
                    ':CDEXCLIENTEIMP' => $CDEXCLIENTEIMP,
                    ':CDCLIENTE' => $CDCLIENTE,
                    ':CDFILIAL' => $CDFILIAL,
                    ':NRORG' => $NRORG,
                    ':OLD_CDEXCLIENTEIMP' => $OLD_CDEXCLIENTEIMP,
                    ':OLD_CDFILIAL' => $OLD_CDFILIAL );
                if(($OLD_CDFILIAL == $CDFILIAL)&&($OLD_CDEXCLIENTEIMP == $CDEXCLIENTEIMP) ){
                    //parametros não modificados.
                }
                else{
                    $result = $this->codigoExternoClientes->editCodigoExterno($params);  
                }
            }
        } catch(\Exception $e){
            $response->setError(new Error($e->getMessage(), $e->getCode()));
            
        }
    }
    
    public function deleteCodigoExterno(DTO\Request $request, DTO\Response $response){
        $row = $this->utilService->getParamsAsArray($request);  

        $NRORG             = $row[0]['NRORG'];
        $CDFILIAL          = $row[0]['CDFILIAL'];
        $CDCLIENTE         = $row[0]['CDCLIENTE'];
        $CDEXCLIENTEIMP    = $row[0]['CDEXCLIENTEIMP'];
        $params = array(
            'CDEXCLIENTEIMP' => $CDEXCLIENTEIMP,
            'CDCLIENTE' => $CDCLIENTE,
            'CDFILIAL' => $CDFILIAL,
            'NRORG' => $NRORG );
        $result = $this->codigoExternoClientes->deleteCodigoExterno($params);  
        $response->addDataSet(new DataSet('ger12400_relacionaCodigoExternoCliente',array()));

	}
	

    
    
}